namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Refrigerate is an ability that turns Normal-type moves into Ice-type moves and boosts their power.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Refrigerate_(Ability)">Bulbapedia - Refrigerate</see>
/// </summary>
[Script(ScriptCategory.Ability, "refrigerate")]
public class Refrigerate : Script, IScriptChangeMoveType, IScriptChangeBasePower
{
    /// <inheritdoc />
    public void ChangeMoveType(IExecutingMove move, IPokemon target, byte hit, ref TypeIdentifier? typeIdentifier)
    {
        if (typeIdentifier?.Name == "normal" &&
            move.Battle.Library.StaticLibrary.Types.TryGetTypeIdentifier("ice", out var iceType))
            typeIdentifier = iceType;
    }

    /// <inheritdoc />
    public void ChangeBasePower(IExecutingMove move, IPokemon target, byte hit, ref ushort basePower)
    {
        if (move.GetHitData(target, hit).Type?.Name == "ice")
            basePower = (ushort)(basePower * 1.2f); // Boost Normal-type moves by 30%
    }
}